/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
	"time"
)

// checks if the UserMessenger type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UserMessenger{}

// UserMessenger struct for UserMessenger
type UserMessenger struct {
	Id string `json:"id"`
	Verified bool `json:"verified"`
	UserId string `json:"user_id"`
	Purpose string `json:"purpose"`
	MessegerId string `json:"messeger_id"`
	MessengerType string `json:"messenger_type"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
	ProfileName *string `json:"profile_name,omitempty"`
}

// NewUserMessenger instantiates a new UserMessenger object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserMessenger(id string, verified bool, userId string, purpose string, messegerId string, messengerType string, createdAt time.Time, updatedAt time.Time) *UserMessenger {
	this := UserMessenger{}
	this.Id = id
	this.Verified = verified
	this.UserId = userId
	this.Purpose = purpose
	this.MessegerId = messegerId
	this.MessengerType = messengerType
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewUserMessengerWithDefaults instantiates a new UserMessenger object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserMessengerWithDefaults() *UserMessenger {
	this := UserMessenger{}
	return &this
}

// GetId returns the Id field value
func (o *UserMessenger) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *UserMessenger) SetId(v string) {
	o.Id = v
}

// GetVerified returns the Verified field value
func (o *UserMessenger) GetVerified() bool {
	if o == nil {
		var ret bool
		return ret
	}

	return o.Verified
}

// GetVerifiedOk returns a tuple with the Verified field value
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetVerifiedOk() (*bool, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Verified, true
}

// SetVerified sets field value
func (o *UserMessenger) SetVerified(v bool) {
	o.Verified = v
}

// GetUserId returns the UserId field value
func (o *UserMessenger) GetUserId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.UserId
}

// GetUserIdOk returns a tuple with the UserId field value
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetUserIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UserId, true
}

// SetUserId sets field value
func (o *UserMessenger) SetUserId(v string) {
	o.UserId = v
}

// GetPurpose returns the Purpose field value
func (o *UserMessenger) GetPurpose() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Purpose
}

// GetPurposeOk returns a tuple with the Purpose field value
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetPurposeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Purpose, true
}

// SetPurpose sets field value
func (o *UserMessenger) SetPurpose(v string) {
	o.Purpose = v
}

// GetMessegerId returns the MessegerId field value
func (o *UserMessenger) GetMessegerId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessegerId
}

// GetMessegerIdOk returns a tuple with the MessegerId field value
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetMessegerIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessegerId, true
}

// SetMessegerId sets field value
func (o *UserMessenger) SetMessegerId(v string) {
	o.MessegerId = v
}

// GetMessengerType returns the MessengerType field value
func (o *UserMessenger) GetMessengerType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.MessengerType
}

// GetMessengerTypeOk returns a tuple with the MessengerType field value
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetMessengerTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.MessengerType, true
}

// SetMessengerType sets field value
func (o *UserMessenger) SetMessengerType(v string) {
	o.MessengerType = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *UserMessenger) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *UserMessenger) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *UserMessenger) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *UserMessenger) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

// GetProfileName returns the ProfileName field value if set, zero value otherwise.
func (o *UserMessenger) GetProfileName() string {
	if o == nil || IsNil(o.ProfileName) {
		var ret string
		return ret
	}
	return *o.ProfileName
}

// GetProfileNameOk returns a tuple with the ProfileName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserMessenger) GetProfileNameOk() (*string, bool) {
	if o == nil || IsNil(o.ProfileName) {
		return nil, false
	}
	return o.ProfileName, true
}

// HasProfileName returns a boolean if a field has been set.
func (o *UserMessenger) HasProfileName() bool {
	if o != nil && !IsNil(o.ProfileName) {
		return true
	}

	return false
}

// SetProfileName gets a reference to the given string and assigns it to the ProfileName field.
func (o *UserMessenger) SetProfileName(v string) {
	o.ProfileName = &v
}

func (o UserMessenger) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UserMessenger) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["verified"] = o.Verified
	toSerialize["user_id"] = o.UserId
	toSerialize["purpose"] = o.Purpose
	toSerialize["messeger_id"] = o.MessegerId
	toSerialize["messenger_type"] = o.MessengerType
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	if !IsNil(o.ProfileName) {
		toSerialize["profile_name"] = o.ProfileName
	}
	return toSerialize, nil
}

type NullableUserMessenger struct {
	value *UserMessenger
	isSet bool
}

func (v NullableUserMessenger) Get() *UserMessenger {
	return v.value
}

func (v *NullableUserMessenger) Set(val *UserMessenger) {
	v.value = val
	v.isSet = true
}

func (v NullableUserMessenger) IsSet() bool {
	return v.isSet
}

func (v *NullableUserMessenger) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserMessenger(val *UserMessenger) *NullableUserMessenger {
	return &NullableUserMessenger{value: val, isSet: true}
}

func (v NullableUserMessenger) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserMessenger) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


